'
' Demonstrate touch hotspots on the Amicsu18 Colour Graphic LCD shield
' Displays eight squares, which will illuminate when touched
' Also displays the X and Y positions of the stylus on the screen
' Written by Les Johnson. September 2011
'  
    Declare Optimiser_Level = 3         ' Maximum optimisation
    Include "ILI9320.inc"               ' Load the graphic LCD routines into the program
    Include "TouchScreen.inc"           ' Load the touch screen routines into the program
'
' Box positions on the LCD
'
    Symbol cBox1_XPos = 8
    Symbol cBox1_Ypos = 48
    Symbol cBox1_Size = 40
    
    Symbol cBox2_XPos = 58
    Symbol cBox2_Ypos = 48
    Symbol cBox2_Size = 40
    
    Symbol cBox3_XPos = 108
    Symbol cBox3_Ypos = 48
    Symbol cBox3_Size = 40
    
    Symbol cBox4_XPos = 158
    Symbol cBox4_Ypos = 48
    Symbol cBox4_Size = 40
    
    Symbol cBox5_XPos = 8
    Symbol cBox5_Ypos = 98
    Symbol cBox5_Size = 40
    
    Symbol cBox6_XPos = 58
    Symbol cBox6_Ypos = 98
    Symbol cBox6_Size = 40
    
    Symbol cBox7_XPos = 108
    Symbol cBox7_Ypos = 98
    Symbol cBox7_Size = 40
    
    Symbol cBox8_XPos = 158
    Symbol cBox8_Ypos = 98
    Symbol cBox8_Size = 40
    
    $define Forever 1 = 1
'--------------------------------------------------------------------
' The main program starts here
'    
Main:  
    Glcd_Cls(clWhite)  
    Glcd_SetFont(Courier_Bold_14)
    Glcd_PaperColor(clWhite)
       
    While Forever                                           ' Create an infinite loop
        If Touch_Active() = tStylusOn Then                  ' Is the stylus touching the screen?           
            Touch_Get()                                     ' Yes. So get its X and Y Pixel positions
            Glcd_PenColor(clBrightBlue)               
            Glcd_Cursor(24,200)
            Print "XPos: ", Dec Touch_X, "    "             ' Display the X position
            Glcd_Cursor(24,220)
            Print "Ypos: ", Dec Touch_Y, "    "             ' Display the Y position
            
            If Touch_TableHotSpot(TouchBox1) = True Then
                Glcd_PenColor(clBrightRed)
                Glcd_SolidRectangle((cBox1_XPos + 1), (cBox1_Ypos + 1), (cBox1_XPos + (cBox1_Size - 1)), (cBox1_Ypos + (cBox1_Size - 1)))    
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox1_XPos + 1), (cBox1_Ypos + 1), (cBox1_XPos + (cBox1_Size - 1)), (cBox1_Ypos + (cBox1_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox2) = True Then
                Glcd_PenColor(clBrightYellow)
                Glcd_SolidRectangle((cBox2_XPos + 1), (cBox2_Ypos + 1), (cBox2_XPos + (cBox2_Size - 1)), (cBox2_Ypos + (cBox2_Size - 1)))
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox2_XPos + 1), (cBox2_Ypos + 1), (cBox2_XPos + (cBox2_Size - 1)), (cBox2_Ypos + (cBox2_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox3) = True Then
                Glcd_PenColor(clBrightGreen)
                Glcd_SolidRectangle((cBox3_XPos + 1), (cBox3_Ypos + 1), (cBox3_XPos + (cBox3_Size - 1)), (cBox3_Ypos + (cBox3_Size - 1))) 
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox3_XPos + 1), (cBox3_Ypos + 1), (cBox3_XPos + (cBox3_Size - 1)), (cBox3_Ypos + (cBox3_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox4) = True Then
                Glcd_PenColor(clBrightMagenta)
                Glcd_SolidRectangle((cBox4_XPos + 1), (cBox4_Ypos + 1), (cBox4_XPos + (cBox4_Size - 1)), (cBox4_Ypos + (cBox4_Size - 1)))
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox4_XPos + 1), (cBox4_Ypos + 1), (cBox4_XPos + (cBox4_Size - 1)), (cBox4_Ypos + (cBox4_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox5) = True Then
                Glcd_PenColor(clBrightGreen)
                Glcd_SolidRectangle((cBox5_XPos + 1), (cBox5_Ypos + 1), (cBox5_XPos + (cBox5_Size - 1)), (cBox5_Ypos + (cBox5_Size - 1)))
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox5_XPos + 1), (cBox5_Ypos + 1), (cBox5_XPos + (cBox5_Size - 1)), (cBox5_Ypos + (cBox5_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox6) = True Then
                Glcd_PenColor(clBrightMagenta)
                Glcd_SolidRectangle((cBox6_XPos + 1), (cBox6_Ypos + 1), (cBox6_XPos + (cBox6_Size - 1)), (cBox6_Ypos + (cBox6_Size - 1)))
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox6_XPos + 1), (cBox6_Ypos + 1), (cBox6_XPos + (cBox6_Size - 1)), (cBox6_Ypos + (cBox6_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox7) = True Then
                Glcd_PenColor(clBrightRed)
                Glcd_SolidRectangle((cBox7_XPos + 1), (cBox7_Ypos + 1), (cBox7_XPos + (cBox7_Size - 1)), (cBox7_Ypos + (cBox7_Size - 1)))
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox7_XPos + 1), (cBox7_Ypos + 1), (cBox7_XPos + (cBox7_Size - 1)), (cBox7_Ypos + (cBox7_Size - 1)))
            EndIf
            
            If Touch_TableHotSpot(TouchBox8) = True Then
                Glcd_PenColor(clBrightYellow)
                Glcd_SolidRectangle((cBox8_XPos + 1), (cBox8_Ypos + 1), (cBox8_XPos + (cBox8_Size - 1)), (cBox8_Ypos + (cBox8_Size - 1)))
            Else
                Glcd_PenColor(clWhite)
                Glcd_SolidRectangle((cBox8_XPos + 1), (cBox8_Ypos + 1), (cBox8_XPos + (cBox8_Size - 1)), (cBox8_Ypos + (cBox8_Size - 1)))
            EndIf
        Else                                                    ' Otherwise... The stylus is not touching the LCD
            '
            ' Clear all the boxes
            '
            Glcd_PenColor(clWhite)
            Glcd_SolidRectangle((cBox1_XPos + 1), (cBox1_Ypos + 1), (cBox1_XPos + (cBox1_Size - 1)), (cBox1_Ypos + (cBox1_Size - 1)))
            Glcd_SolidRectangle((cBox2_XPos + 1), (cBox2_Ypos + 1), (cBox2_XPos + (cBox2_Size - 1)), (cBox2_Ypos + (cBox2_Size - 1)))
            Glcd_SolidRectangle((cBox3_XPos + 1), (cBox3_Ypos + 1), (cBox3_XPos + (cBox3_Size - 1)), (cBox3_Ypos + (cBox3_Size - 1)))
            Glcd_SolidRectangle((cBox4_XPos + 1), (cBox4_Ypos + 1), (cBox4_XPos + (cBox4_Size - 1)), (cBox4_Ypos + (cBox4_Size - 1)))
            Glcd_SolidRectangle((cBox5_XPos + 1), (cBox5_Ypos + 1), (cBox5_XPos + (cBox5_Size - 1)), (cBox5_Ypos + (cBox5_Size - 1)))
            Glcd_SolidRectangle((cBox6_XPos + 1), (cBox6_Ypos + 1), (cBox6_XPos + (cBox6_Size - 1)), (cBox6_Ypos + (cBox6_Size - 1)))
            Glcd_SolidRectangle((cBox7_XPos + 1), (cBox7_Ypos + 1), (cBox7_XPos + (cBox7_Size - 1)), (cBox7_Ypos + (cBox7_Size - 1)))
            Glcd_SolidRectangle((cBox8_XPos + 1), (cBox8_Ypos + 1), (cBox8_XPos + (cBox8_Size - 1)), (cBox8_Ypos + (cBox8_Size - 1)))
            '
            ' Clear all the box outlines
            '
            Glcd_PenColor(clBlack)
            Glcd_Box(cBox1_XPos,cBox1_Ypos,cBox1_Size)
            Glcd_Box(cBox2_XPos,cBox2_Ypos,cBox2_Size)
            Glcd_Box(cBox3_XPos,cBox3_Ypos,cBox3_Size)
            Glcd_Box(cBox4_XPos,cBox4_Ypos,cBox4_Size)
            Glcd_Box(cBox5_XPos,cBox5_Ypos,cBox5_Size)
            Glcd_Box(cBox6_XPos,cBox6_Ypos,cBox6_Size)
            Glcd_Box(cBox7_XPos,cBox7_Ypos,cBox7_Size)
            Glcd_Box(cBox8_XPos,cBox8_Ypos,cBox8_Size)
        EndIf
    Wend
'-------------------------------------------------------------------------------------------------------
' Hotspot tables
'
' Format: Xstart, Ystart, Xend, Yend  
'
TouchBox1: 
    CData Byte cBox1_XPos, Word cBox1_Ypos, Byte (cBox1_XPos + cBox1_Size), Word (cBox1_Ypos + cBox1_Size)
TouchBox2:
    CData Byte cBox2_XPos, Word cBox2_Ypos, Byte (cBox2_XPos + cBox2_Size), Word (cBox2_Ypos + cBox2_Size)
TouchBox3:
    CData Byte cBox3_XPos, Word cBox3_Ypos, Byte (cBox3_XPos + cBox3_Size), Word (cBox3_Ypos + cBox3_Size)
TouchBox4:
    CData Byte cBox4_XPos, Word cBox4_Ypos, Byte (cBox4_XPos + cBox4_Size), Word (cBox4_Ypos + cBox4_Size) 
TouchBox5: 
    CData Byte cBox5_XPos, Word cBox5_Ypos, Byte (cBox5_XPos + cBox5_Size), Word (cBox5_Ypos + cBox5_Size)
TouchBox6:
    CData Byte cBox6_XPos, Word cBox6_Ypos, Byte (cBox6_XPos + cBox6_Size), Word (cBox6_Ypos + cBox6_Size)
TouchBox7:
    CData Byte cBox7_XPos, Word cBox7_Ypos, Byte (cBox7_XPos + cBox7_Size), Word (cBox7_Ypos + cBox7_Size)
TouchBox8:
    CData Byte cBox8_XPos, Word cBox8_Ypos, Byte (cBox8_XPos + cBox8_Size), Word (cBox8_Ypos + cBox8_Size)

'-------------------------------------------------------------------------------------------------------
' Load the font into the program
'
    Include "Courier_Bold_14.inc"       
